{--

  Count number of papers assigned to each referee.

--}

schema conf = "conference.xsd"
schema refs = "referees.xsd"

define function referee-counts(
  element conf:conference $conf
) returns element refs:referees {
  <refs:referees>{
    for $r in distinct-values($conf/conf:paper/conf:referee)
    return
      let $c :=
        count(
          for $p in $conf/conf:paper
          where $p/conf:referee = $r
          return $p
        )
      return
        <refs:referee>
          <refs:name>{ data($r) }</refs:name>
          <refs:count>{ $c }</refs:count>
        </refs:referee>
  }</refs:referees>
}

let
  $conf := treat as document conf:conference ( document("conference.xml") )
return
  referee-counts($conf/conf:conference)





