{--

  Count number of papers assigned to each referee.

--}

define element conference {
  element paper *
}

define element paper {
  element title { xsd:string } ,
  element authors { xsd:string } ,
  element referee { xsd:string } *
}

define element referees {
  element referee {
    attribute count { xsd:int } ,
    xsd:string
  } *
}

define function referee-counts(
  element conference $conf
) returns element referees {
  <referees>{
    for $r in distinct-values($conf/paper/referee)
    return
      let $c :=
        count(
          for $p in $conf/paper
          where $p/referee = $r
          return $p
        )
      return
        <referee count="{$c}">{ data($r) }</referee>
  }</referees>
}

let
  $conf := treat as document conference ( document("conference.xml") )
return
  referee-counts($conf/conference)





