{--

  Check that the total number of papers assigned to all referees
  equals the total number of referees assigned to all papers.

--}

define element conference {
  element paper *
}

define element paper {
  element title { xsd:string } ,
  element authors { xsd:string } ,
  element referee { xsd:string } *
}

define element referees {
  element referee {
    attribute count { xsd:int } ,
    xsd:string
  } *
}

define function referee-counts(
  element conference $conf
) returns element referees {
  <referees>{
    for $r in distinct-values($conf/paper/referee)
    return
      let $c :=
        count(
          for $p in $conf/paper
          where $p/referee = $r
          return $p
        )
      return
        <referee count="{$c}">{ data($r) }</referee>
  }</referees>
}

let
  $conf := treat as document conference ( document("conference.xml") ) ,
  $refs := referee-counts($conf/conference) ,
  $counts := for $count in $refs/referee/@count return data($count) ,
  $counts2 := for $paper in $conf/conference/paper return count($paper/referee)
return
  sum-int($counts) = sum-int($counts2)
  
  





