{--

  Rename title and authors to title-i and author-i,
  where i is the paper number.

--}

define element conference {
  element paper {
    element title { xsd:string } ,
    element authors { xsd:string } ,
    element referee { xsd:string } *
  } *
}

define function int-to-string(
  xsd:int $i
) returns xsd:string {
  string-value( <dummy>{ $i }</dummy> )
}

define function rename(
  element conference $conf
) returns element conference {
  <conference>{
    for $paper in $conf/paper
    let $i := int-to-string(index-of($conf/paper, $paper))
    return
      <paper>
        <title>{ concat("title-", $i) }</title>
        <authors>{ concat("authors-", $i) }</authors>
        { $paper/referee }
      </paper>
  }</conference>
}

let
  $conf := treat as document conference ( document("conference.xml") )
return
  rename($conf/conference)





